<template>
    <div class="autocomplete">
        <label v-if="label" :for="identifier">{{ label }}</label>
        <input type="text" :name="identifier" :id="identifier" v-model="search" @input="onSearchChange" :placeholder="placeholder" :disabled="disabled"/>
        <ul v-show="isOpen" class="autocomplete-results">
            <li v-if="nullable" @click="setNull" class="autocomplete-result">
                {{ nullable_text }}
            </li>
            <li v-for="(result, index) in results" :key="index" class="autocomplete-result" @click="setResult(result)">
                <div>{{ result[item_text] }}</div>
            </li>
        </ul>
        <div class="fieldchanger-error" v-if="error">
            {{ error }}
        </div>
        <div class="fieldchanger-hint" v-if="hint">
            {{ hint }}
        </div>
    </div>
</template>

<script>
    import DatabaseFieldchanger from "./DatabaseFieldchanger";

    export default {

        extends: DatabaseFieldchanger,

        props: {
            items_url: {
                type: String,
                required: true,
            },

            item_text: {
                type: String,
                required: true,
            },

            item_value: {
                type: String,
                default: 'id',
            },

            nullable: {
                type: Boolean,
                default: false,
            },

            nullable_text: {
                type: String,
                default: '-',
            },

            placeholder: {
                type: String,
                default: null,
            }
        },

        data() {
            return {
                items: [],
                search: '',
                results: [],
                isOpen: false,
            }
        },

        methods: {
            getItems() {
                this.isLoading = true;

                axios.get(this.items_url)
                    .then(response => {
                        this.items = response.data;
                        this.getItemName();
                        this.isLoading = false;
                    });
            },

            getItemName() {
                if (this.items.length && this.current_value !== null) {
                    let selected = this.items.find((item) => {
                        return item[this.item_value] === this.current_value
                    });

                    if (selected) {
                        this.search = selected[this.item_text];
                    }
                }

                return null;
            },

            onSearchChange() {
                this.isOpen = true;
                this.filterResults();
            },

            filterResults() {
                let self = this;
                this.results = this.items.filter(function (item) {
                    return item[self.item_text].toLowerCase().indexOf(self.search.toLowerCase()) > -1
                });
            },

            setNull() {
                this.new_value = null;
                this.change();
                this.isOpen = false;
                this.search = '';
            },

            setResult(result) {
                this.new_value = result[this.item_value];
                this.change();
                this.isOpen = false;
                this.search = result[this.item_text];
            },
        },

        mounted() {
            this.getItems();
        }

    }
</script>

<style>
    .autocomplete {
        position: relative;
        width: 130px;
    }

    .autocomplete-results {
        padding: 0;
        margin: 0;
        border: 1px solid #eeeeee;
        overflow: auto;
    }

    .autocomplete-result {
        list-style: none;
        text-align: left;
        padding: 4px 2px;
        cursor: pointer;
    }

    .autocomplete-result:hover {
        background-color: #4AAE9B;
        color: white;
    }
</style>